<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty show modifier plugin
 *
 * Type:     modifier<br>
 * Name:     local_word<br>
 * Purpose:  designate default value for empty variables
 * @param string [in]database flag value
 * @param array  [in]entries of labels for database flag value
 * @return string 
 */
function smarty_modifier_local_word($string, $valArray)
{
    if (isset($string) && is_array($valArray) && isset($valArray[$string]))
    {
        return $valArray[$string];
    }

    return '';
}

?>
