<?php
//------------------------------------------------------------------------------
//--                                                                          --
//--    FILE NAME :  IntSmartyMailer.class.php                                --
//--                                                                          --
//--        Designed by NeoJapan   2005-11-27   Ver. 1.00                     --
//--        Coded    by NeoJapan   2005-11-27   Ver. 1.00                     --
//--        Revised  by XXXXXXXXX  XXXX-XX-XX   Ver. X.00                     --
//--                                                                          --
//------------------------------------------------------------------------------
//--   (C)COPYRIGHT 2005 BY NeoJapan CORPORATION ALL RIGHTS RESERVED          --
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// 󥯥롼
//------------------------------------------------------------------------------
require_once('neomailer.class.php');
require_once(SMARTY_DIR . 'IntSmarty.class.php');

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
define('NEOMAILER_TEMPLATES_ERROR', 'Template Error[IntsmartyMailer]');
//------------------------------------------------------------------------------
// 饹
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//--    饹 IntSmartyMailer                                              --
//--    Class  IntSmartyMailer                                              --
//------------------------------------------------------------------------------
//--  MODIFIED        YYYY-MM-DD REV    - NOTES                               --
//--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                          --
//------------------------------------------------------------------------------
/**
 * Ȥä᡼
 *      :
 *      : php4.3.0ʹ
 */
class IntSmartyMailer extends NeoMailer
{
    /**
     * ᡼ƥ
     * @access public
     * @type string
     */
    var $MailText = '';

    /**
     * ᡼ƥץ졼ȥե
     * @access public
     * @type string
     */
    var $TemplateFile = '';

    /**
     * Smarty
     *
     * @type IntSmarty
     */
    var $intSmarty = null;

    /**
     * 
     * @final
     */
    var $newline  = "\n";   // 
    var $from_key = 'from'; // fromΥ
    var $to_key = 'to';     // toΥ
    var $cc_key = 'cc';     // ccΥ
    var $bcc_key = 'bcc';   // bccΥ
    var $subject_key = 'subject';  // subjectΥ
    var $attachment_key = 'attachment'; // attachmentΥ

    //--------------------------------------------------------------------------
    // 󥹥ȥ饯
    //--------------------------------------------------------------------------
    /**
     *
     * @param  string  $lang   [IN]:
     */
    function IntSmartyMailer($lang = null)
    {
        $this->intSmarty = & new IntSmarty($lang);
    }

    //--------------------------------------------------------------------------
    // 󥹥󥹥᥽å
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    //--    ؿ̾ ᡼                                               --
    //--    Method Send()                                                   --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * Ȥäƥ᡼򤹤롣
     *
     * @return bool    trueǤʤfalse
     */
    function Send()
    {
        // ǤƹԤʬ
        $text = $this->intSmarty->fetch($this->TemplateFile);
        if (!$text)
        {
            $this->SetError(NEOMAILER_TEMPLATES_ERROR);
            return false;
        }

        $this->MailText = $text;

        $textlines = explode($this->newline, $this->MailText);

        //[ إå ]
        for ($i = 0; $i < count($textlines); $i++)
        {
            $address = '';
            $name    = '';
            $type    = '';

            // ԤʤХإåλ
            if (strlen(trim($textlines[$i])) <= 0)
            {
                $i++;
                break;
            }
            else if (strcasecmp(trim($textlines[$i]), 'html') == 0)
            {
                $this->IsHTML(true);
            }
            // FromʤХǡ
            else if ($this->rm_parseAddress($textlines[$i], $this->from_key, $address, $name))
            {
                $this->From = $address;
                $this->FromName = $name;
            }
            // ToʤХǡ
            else if ($this->rm_parseAddress($textlines[$i], $this->to_key, $address, $name))
            {
                $this->AddAddress($address, $name);
            }
            // CcʤХǡ
            else if ($this->rm_parseAddress($textlines[$i], $this->cc_key, $address, $name))
            {
                $this->AddCc($address, $name);
            }
            // BccʤХǡ
            else if ($this->rm_parseAddress($textlines[$i], $this->bcc_key, $address, $name))
            {
                $this->AddBcc($address);
            }
            // SubjectʤХǡ
            else if ($this->rm_parseText($textlines[$i], $this->subject_key, $text))
            {
                $this->Subject = $text;
            }
            // Attachementʤźեե
            else if ($this->rm_parseAttachment($textlines[$i], $this->attachment_key, $text, $name, $type))
            {
                $ret = $this->AddAttachment($text, $name, 'base64', $type);
                if (!$ret)
                {
                    return false;
                }
            }
            // ¾Υإå
            else
            {
                $this->AddCustomHeader($textlines[$i]);
            }
        }

        // ʸ
        $this->Body = implode($this->newline, array_slice($textlines, $i));

        return parent::Send();
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ͤ                                             --
    //--    Method bm_assign()                                              --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-01 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ͤࡣ
     *
     * @param  string  $key        [IN]:
     * @param  string  $value      [IN]:
     */
    function bm_assign($key, $value = null)
    {
        $this->intSmarty->assign($key, $value);
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ɥ쥹β                                         --
    //--    Method rm_parseAddress()                                        --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ΥإåΥɥ쥹Ϥ롣
     *
     * @param  string  $text       [IN]:ΰ
     * @param  string  $key        [IN]:̾
     * @param  string  &$address   [OUT]:᡼륢ɥ쥹
     * @param  string  &$name      [OUT]:̾
     * @return bool    ˳true
     */
    function rm_parseAddress($text, $key, &$address, &$name)
    {
        $parts = explode(':', $text, 3);

        // ꤷʪȰ㤦ϰʤ
        if (count($parts) < 2 || strcasecmp(trim($parts[0]), $key))
        {
            return false;
        }
        // 2
        if (count($parts) > 2)
        {
            $address = trim($parts[1]);
            $name = trim($parts[2]);
        }
        // 1
        else
        {
            $address = trim($parts[1]);
            $name = null;
        }

        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ źեեβ                                       --
    //--    Method rm_parseAttachment()                                     --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-12-01 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ΥإåźեեϤ롣
     *
     * @param  string  $text       [IN]:ΰ
     * @param  string  $key        [IN]:̾
     * @param  string  &$path      [OUT]:եѥ
     * @param  string  &$name      [OUT]:̾
     * @param  string  &$type      [OUT]:MIME TYPE
     * @return bool    ˳true
     */
    function rm_parseAttachment($text, $key, &$path, &$name, &$type)
    {
        $text_out = '';

        // Ȥʳʬ
        $ret = $this->rm_parseText($text, $key, $text_out);
        if (!$ret)
        {
            return $ret;
        }

        $parts = explode(';', $text_out, 3);
        // ꤷʪȰ㤦ϰʤ
        if (count($parts) < 1)
        {
            return false;
        }
        // 3
        if (count($parts) > 2)
        {
            $path = trim($parts[0]);
            $name = trim($parts[1]);
            $type = trim($parts[2]);
        }
        // 2
        else if (count($parts) == 2)
        {
            $path = trim($parts[0]);
            $name = trim($parts[1]);
            $type = 'application/octet-stream';
        }
        // 1
        else
        {
            $path = trim($parts[0]);
            $name = '';
            $type = 'application/octet-stream';
        }

        return true;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ ʸβ                                           --
    //--    Method rm_parseText()                                           --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2005-11-27 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * ΥإåʸϤ롣
     *
     * @param  string  $text       [IN]:ΰ
     * @param  string  $key        [IN]:̾
     * @param  string  &$text_out  [OUT]:ʸ
     * @return bool    ˳true
     */
    function rm_parseText($text, $key, &$text_out)
    {
        $parts = explode(':', $text, 2);

        // ꤷʪȰ㤦ϰʤ
        if (count($parts) < 2 || strcasecmp(trim($parts[0]), $key))
        {
            return false;
        }
        // 1
        else
        {
            $text_out = trim($parts[1]);
        }

        return true;
    }
}
?>