/**
 * 現在時刻の設定
 */
function setDate(objform, txt_prefix) {

    var objDate = new Date();

    //[ フォームの各項目について繰り返し ]
    for(var i_cnt=0; i_cnt < objform.elements.length; i_cnt++) {

        // ある接頭辞をもつcheckboxのみ設定する。
        if (objform.elements[i_cnt].type == 'text') {

            if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Year]") == 0) {
                var iy = objDate.getYear();
                if(iy < 2000) iy += 1900;

                objform.elements[i_cnt].value = iy;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Month]") == 0) {
                var im = objDate.getMonth() + 1;
                if(im < 10) im = "0" + im;

                objform.elements[i_cnt].value = im;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Day]") == 0) {
                var idy = objDate.getDate();
                if(idy< 10) idy = "0" + idy;

                objform.elements[i_cnt].value = idy;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Hour]") == 0) {
                var ihs = objDate.getHours();
                if(ihs < 10) ihs = "0" + ihs;

                objform.elements[i_cnt].value = ihs;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Minute]") == 0) {
                var ims = objDate.getMinutes();
                if(ims < 10) ims = "0" + ims;

                objform.elements[i_cnt].value = ims;
            }
        }
    }
}
