/*
 * 入力チェック
 * （サブミットボタンにonclickでvalidateChkForm(this)を指定する。
 */
function validateChkSreach(submitElement)
{
    // 戻り値
    var bCanSubmit = true;

    // 関数戻り値
    var bRet = false;

    // キーワードチェック
    bRet = validateChkKeyword(submitElement);
    if (bRet == false) {
       bCanSubmit = false;
    }


    // 日付チェック
    bRet = validateDateFromToChkForm(submitElement);
    if (bRet == false) {
       bCanSubmit = false;
    }

    // からまでを含む日付チェック
    bRet = validateDateChkForm(submitElement);
    if (bRet == false) {
       bCanSubmit = false;
    }

    // 処理終了
    return bCanSubmit;
}
/*
 * 入力チェック
 * （サブミットボタンにonclickでvalidateChkForm(this)を指定する。
 */
function validateChkKeyword(submitElement)
{
    // 戻り値
    var bCanSubmit = true;

    // クラス
    $('.chk_sreach').removeClass('chk_err_area');
    $(".chk_err_msg").hide();
    $(".chk_sreach_keyword_required_msg").hide();
    $(".chk_sreach_columns_msg").hide();

    // キーワードを取得
    var sKeyWord  = $('input[name="s_keyword"]').val();
    // 1つ目にチェックされている値を取得
    var sChk      = $('input[name="s_columns[]"]:checked').val();

    // 片方入力
    if ((sKeyWord != "" && sChk != null)
     || (sKeyWord == "" && sChk == null)
    ) {
    }
    else {
        bCanSubmit = false;

        // クラスを追加
        $('.chk_sreach').addClass('chk_err_area');

        // エラーメッセージ表示枠
        $(".chk_sreach .chk_err_msg").show();
        // エラーの内容表示
        if (sKeyWord == "") {
            $(".chk_sreach .chk_sreach_keyword_required_msg").show();
        }
        // エラーの内容表示
        else if (sChk == null){
            $(".chk_sreach .chk_sreach_columns_msg").show();
        }
    }

    // 処理終了
    return bCanSubmit;
}
