<?php
//------------------------------------------------------------------------------
//--                                                                          --
//--    FILE NAME :  IntSmartyRenderer.class.php                              --
//--                                                                          --
//--        Designed by NeoJapan   2005-07-11   Ver. 1.00                     --
//--        Coded    by NeoJapan   2005-07-11   Ver. 1.00                     --
//--        Revised  by XXXXXXXXX  XXXX-XX-XX   Ver. X.00                     --
//--                                                                          --
//------------------------------------------------------------------------------
//--   (C)COPYRIGHT 2005 BY NeoJapan CORPORATION ALL RIGHTS RESERVED          --
//------------------------------------------------------------------------------
//--    : IntSmartymojaviǻȤΥ饹
//--    : php4.3.0ʹ

//------------------------------------------------------------------------------
// 󥯥롼
//------------------------------------------------------------------------------
require_once(SMARTY_DIR . 'IntSmarty.class.php');
require_once(RENDERER_DIR . 'SmartyRenderer.class.php');

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
// 饹
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//--    饹 IntSmartyRenderer                                            --
//--    Class  IntSmartyRenderer                                            --
//------------------------------------------------------------------------------
//--  MODIFIED        YYYY-MM-DD REV    - NOTES                               --
//--  NEOJAPAN        2005-07-11 1.00   - CREATE NEW                          --
//------------------------------------------------------------------------------
/**
 * IntSmartymojaviǻȤΥ饹
 */
class IntSmartyRenderer extends SmartyRenderer {

    //--------------------------------------------------------------------------
    //  󥹥ȥ饯
    //--------------------------------------------------------------------------
    //----[ 󥹥ȥ饯ף ]--------------------------------------------
    /**
     * ֥ȤνԤ
     */
    function IntSmartyRenderer(
        $controller
      , $request
      , $user
    ){
        parent::Renderer();

        /*[ 桼Ѹ ]*/
        if ($user->getAttribute(USER_LANGUAGE)){
            $lang = $user->getAttribute(USER_LANGUAGE);
        }
        else {
            $lang = 'ja';
        }

        /*[ IntSmartyRendererѰ ]*/
        $this->engine = & new IntSmarty($lang);

        /** ȥ顼Ƽ **/
        $module     = $controller->getCurrentModule();
        $action     = $controller->getCurrentAction();
        $module_dir = $controller->getModuleDir();

        /** Ƽѥκ **/
        $compile_dir = SMARTY_COMPILE_DIR . $module . DIRECTORY_SEPARATOR;
        $cache_dir   = SMARTY_CACHE_DIR   . $module . DIRECTORY_SEPARATOR;
        $config_dir  = $module_dir . 'config' . DIRECTORY_SEPARATOR;
        $lang_dir    = $module_dir . 'config' . DIRECTORY_SEPARATOR
                       . 'messages_';
        $deflang_path= MODULE_DIR.'Default'.DIRECTORY_SEPARATOR
                       . 'config' . DIRECTORY_SEPARATOR
                       . 'messages_';

        /*[ ǥ쥯ȥ̵꤬к롣]*/
        if(!file_exists($compile_dir)){
            mkdir($compile_dir);
        }
        if(!file_exists($cache_dir)){
            mkdir($cache_dir);
        }

        /** ѥ᡼ **/
        $this->engine->cache_dir     = $cache_dir;
        $this->engine->plugins_dir   = array(APP_SMARTY_PLUGIN_DIR, 'plugins');
        $this->engine->compile_dir   = $compile_dir;
        $this->engine->config_dir    = $config_dir;
        $this->engine->compiler_file = SMARTY_DIR . $this->engine->compiler_file;
        $this->engine->force_compile = SMARTY_FORCE_COMPILE;
        $this->engine->debugging     = SMARTY_DEBUGGING;
        $this->engine->lang_path     = $lang_dir;
        $this->engine->deflang_path  = $deflang_path;
        $this->engine->default_lang  = SMARTY_DEFAULT_LANG;
        if(!SMARTY_DEBUGGING){
            $this->engine->default_modifiers = array('neo_escape:"html"');
        }

        /*[ ݲб ]*/
        $this->engine->loadLanguageTable($lang);
    }

    /**
     * Set an attribute.
     *
     * @param string An attribute name.
     * @param mixed  An attribute value.
     *
     * @access public
     * @since  1.0
     */
    function setAttribute ($name, $value, $defval = '')
    {
        if( isset($value) ){
            $this->engine->assign($name, $value);
        }else{
            $this->engine->assign($name, $defval);
        }
    }
}
?>