// 画面が読み終わったら、埋め込みをするかしないか確認
$(document).ready(function() {
    jConfirm('保存されている一時データを復元しますか？', '確認',function(bRet){
        if(bRet) {

            // 登録画面は0で送信
            var i_entry_id = $('input[name="i_entry_id"]').val();
            if (i_entry_id == null || i_entry_id == "") {
                i_entry_id = "0";
            }

            // 現在のblogのID
            var edtblg = $('#edtblg').val();

            // URL
            var base_url = 'index.php';

            // Ajax通信
            $.ajax({
                type     : "post",
                dataType : "xml",
                url      : base_url,
                timeout  : 30000 ,
                data     : {
                            "module"    : "User",
                            "action"    : "EntryGetTmp",
                            "i_entry_id": i_entry_id,
                            "edtblg"    : edtblg
                           },
                success  : ok_set_tmpdata,
                error    : ng_set_tmpdata
            });
        }
        // 自動実行
        AutoSavesetTimer();
    });
});
// 成功
function ok_set_tmpdata(res, res_stat){
    // データ取得OK?
    // 成功失敗を取得
    var ret = $('status', res).text();
    var message = "";
    if (ret == 'ok') {

        // タイトル
        var entry_title = $('entrytitle', res).text();
        $('input[name="i_title"]').val(entry_title);

        // 公開設定
        var sPublicFlg = $('publicflg', res).text();
        $('select[name="i_public_flg"]').val(sPublicFlg);

        // 時間
        var publicdateyy = $('publicdateyy', res).text();
        $('input[name="i_public_date[Year]"]').val(publicdateyy);
        var publicdatemm = $('publicdatemm', res).text();
        $('input[name="i_public_date[Month]"]').val(publicdatemm);
        var publicdatedd = $('publicdatedd', res).text();
        $('input[name="i_public_date[Day]"]').val(publicdatedd);
        var publicdatehh = $('publicdatehh', res).text();
        $('input[name="i_public_date[Hour]"]').val(publicdatehh);
        var publicdatemi = $('publicdatemi', res).text();
        $('input[name="i_public_date[Minute]"]').val(publicdatemi);

        // カテゴリ
        var categoryid = $('categoryid', res).text();
        categoryid = "," + categoryid + ",";
        // カテゴリのループ
        $('input[name="i_category_id[]"]').each(function() {
            // カテゴリのValueを取得
            var ctid = $(this).val();
            ctid = "," + ctid + ",";
            if (categoryid.indexOf(ctid) != -1) {
                // チェック追加
                $(this).attr("checked", true);
            }
        });

        
        // カテゴリ名
        var categoryname = $('categoryname', res).text();
        $('input[name="i_category_text"]').val(categoryname);
        
        // ディレクトリ
        var directoryid = $('directoryid', res).text();
        $('select[name="i_directory_id"]').val(directoryid);

        // 本文
        var entrytext = $('entrytext', res).text();
        $('#i_entry_text').val(entrytext)

        // 追記
        var entrytextmore = $('entrytextmore', res).text();
        $('#i_entry_text_more').val(entrytextmore)

        // トラックバック先URL
        var trackbackurl = $('trackbackurl', res).text();
        $('textarea[name="i_trackback_url"]').val(trackbackurl);

        // 概要
        var entrysummary = $('entrysummary', res).text();
        $('textarea[name="i_entry_summary"]').val(entrysummary);
    }
    else{
        message = $('errormessage', res).text();
        jAlert(message, '確認',function(bRet){
            if(bRet) {
            }
        });
    }
};

// 失敗
function ng_set_tmpdata( XMLHttpRequest, status, errorThrown ){
};
