/**
 * カレンダー画面を別ウィンドウに表示
 */
function openCalendar(txt_prefix) {

    file_selecter_uri = 'index.php?module=Calendar&new_window=1&prefix=' + txt_prefix;

    file_selecter_window = window.open(encodeURI(file_selecter_uri), 'Calendar'
            , 'width=260,height=200,scrollbars=yes,location=no,menubar=no,directories=no');
    return true;
}

/**
 * 親の画面の入力欄に選択された日付をセット
 * 
 * @param  object  t_form  [IN]:対象フォーム
 */
function setDateOpener(txt_prefix, _year, _month, _day)
{
    var bonochangeopener = true;

    wp = window.opener;
    if(wp == null || wp.closed) {
        alert("呼び出した画面が既に閉じられてる為、終了します。");
        window.close();
        return;
    }

    objform = wp.document.frm;

    if(wp.document.frm == null) {
        alert("呼び出した画面が既に変更されている為、終了します。");
        window.close();
        return;
    }

    if(_month < 10) _month = "0" + _month;
    if(_day < 10)   _day   = "0" + _day;

    //[ フォームの各項目について繰り返し ]
    for(var i_cnt=0; i_cnt < objform.elements.length; i_cnt++) {

        // ある接頭辞をもつcheckboxのみ設定する。
        if(objform.elements[i_cnt].type == 'text') {

            if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Year]") == 0) {
                bonochangeopener = false;
                objform.elements[i_cnt].value = _year;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Month]") == 0) {
                bonochangeopener = false;
                objform.elements[i_cnt].value = _month;
            }
            else if(objform.elements[i_cnt].name.indexOf(txt_prefix + "[Day]") == 0) {
                bonochangeopener = false;
                objform.elements[i_cnt].value = _day;
            }
        }
    }

    //[ 該当エレメントなし ]
    if(bonochangeopener) {
        alert("呼び出した画面が既に変更されている為、終了します。");
        window.close();
        return;
    }

    window.close();
}
