// ファイルの一覧からファイル情報埋め込み
function setFileSelEdit(btnobj,filename,blogid,fileid,position)
{

    // 親ウィンドウの存在チェック
    if ( ! window.opener || typeof(window.opener.insertFileEdit) == "undefined")
    {
        var ret = alert("親画面が閉じているため、ファイルを挿入できません。");
        window.close();
        return false;
    }

    // blogが変わってる？
    var open_blog_sys_id = $('input[name="edtblg"]',window.opener.document).val();
    var now_blog_sys_id = $('input[name="edtblg"]').val();
    if (open_blog_sys_id != now_blog_sys_id) {
        var ret = alert("ブログが変更されているため、ファイルを挿入できません。");
        window.close();
        return false;
    }

    // クリックされたボタンから親のTDを取得する。
    var elTable = $(btnobj).parents('table:first');

    // TD内からinputタグを取得
    var widthsize = elTable.find('input[name="filewidth"]').val();

    var img_flg    ="";
    var img_height ="";
    var img_width  ="";
    var text       ="";
    var imglink    ="";

    // inputタグが存在しない場合は画像でない。

    if (widthsize == null) {
        img_flg    = '&image=1';
    }
    else {

        // TD内からinputタグを取得
        var defimage_width = elTable.find('input[name="defimage_width"]').val();
        // TD内からinputタグを取得
        var defimage_height = elTable.find('input[name="defimage_height"]').val();

        // TD内からチェックボックスのチェックを取得
        imglink = elTable.find('input[name="imglink"]:checked').val();

        if (imglink == null) {
            imglink = "";
        }

        // INT変換
        widthsize       = Number(widthsize,10);
        defimage_width  = parseInt(defimage_width,10);
        defimage_height = parseInt(defimage_height,10);

        if (isNaN(widthsize) || widthsize <= 0) {
            alert("数字を入力してください。");
            return;
        }
        else {

            // 横のサイズから縦を計算
            var heightsize = defimage_height * widthsize / defimage_width;
            heightsize = parseInt(heightsize);
        }

        img_height = heightsize;
        img_width  = widthsize;
    }

    var img_src = 'index.php?module=Default&action=GetFile'+'&i_file_name='+encodeURIComponent(filename)+'&blog_sys_id='+blogid+img_flg+'&i_file_id='+fileid;

    img_src = tinymce.DOM.decode(img_src);

    var editor_tabs = $('#frm #entry_editor',window.opener.document).tabs();

    var selected = editor_tabs.tabs('option', 'selected');

    var objEditor;
    if (selected == 0) {
        objEditor = $('#frm #entry_editor',window.opener.document).find('#i_entry_text');
    }
    else {
        objEditor = $('#frm #entry_editor',window.opener.document).find('#i_entry_text_more');
    }

    if (widthsize == null) {
        text = tinymce.DOM.createHTML('img', {
			src : img_src,
            align : position,
            alt : filename
		});
    }
    else {
        text = tinymce.DOM.createHTML('img', {
			src : img_src,
            align : position,
            width : img_width,
            height : img_height,
            alt : filename
		});
    }

    // 画像のリンクを追加する？
    if (imglink != "") {
        var text = '<a href="index.php?module=Default&action=GetFile&blog_sys_id=' + blogid + '&i_file_id=' + fileid + '" target="_blank">' + text + '</a>';
    }

    window.opener.insertFileEdit(text);
    window.close();
};

// ファイルのpxをデフォルトに戻す
function clearFileSelPx(btnobj)
{
    // クリックされたボタンから親のTDを取得する。
    var elTd = $(btnobj).parents('td:first');
    // TD内からinputタグを取得
    var defimage_width = elTd.find('input[name="defimage_width"]').val();
    // TD内からinputタグを取得
    elTd.find('input[name="filewidth"]').val(defimage_width);
};
