function insertFileEdit(text) {

    var editor_tabs = $('#frm #entry_editor').tabs();
    var selected = editor_tabs.tabs('option', 'selected');

    var objEditor;
    if (selected == 0) {
        objEditor = $('#frm #entry_editor').find('#i_entry_text');
    }
    else {
        objEditor = $('#frm #entry_editor').find('#i_entry_text_more');
    }

    objEditor.tinymce().execCommand('mceInsertRawHTML', false, text);

}


// 画面が読み終わったら、ファイルアップロードの処理を定義
$(document).ready(function() {
    $("#ajaxuploadform").ajaxForm({
        // 設定
        dataType: "xml",
        // 通信成功
        success: function (res, res_stat) {

            // ファイルの一覧読み直し
            getFileList(1);

            // ファイル名クリア
            $('#imageuptext').find("span:last").remove();
            $('#imageuptext').append(  '<span>' + '<input type=\"file\" name=\"i_file\">' + '</span>'  );

            // 成功失敗を取得
            var ret = $('status', res).text();
            var message = "";
            if (ret == 'ok') {
                message = $('message', res).text();
            }
            else{
                message = $('errormessage', res).text();
            }

            // 成功メッセージ追加
            $('#fileuplodemsg').find("span:last").remove();
            $('#fileuplodemsg').append( '<span>' + message + '</span>');
        },
        // 通信失敗
        error: function (xml, status, e) {

            // ファイルの一覧読み直し
            getFileList(1);

            // ファイル名クリア
            $('#imageuptext').find("span:last").remove();
            $('#imageuptext').append(  '<span>' + '<input type=\"file\" name=\"i_file\">' + '</span>'  );

            // エラーメッセージ埋め込み
            $('#fileuplodemsg').append(  "通信に失敗しました。"  );
        }
    });
});

// 画面が読み終わったら、ファイルの一覧を取得
$(document).ready(function()
{

    // 接続先のURL取得
    var base_dir = $('#base_dir')[0].innerHTML;
    var base_url = base_dir + 'index.php';

    var aj_url = base_url + '?module=User&action=FileListAjax&fr=1&edtblg=' + $('#edtblg').val();

    $.ajax({
        url: aj_url,
        timeout: 30000 ,
        success: ok_filelist ,
        error  : ng_filelist
    });
});

// ファイル一覧のページ遷移、ファイルアップロード後の再読み込み
function getFileList(page)
{
    $('#file_list').find("span:last").remove();
    $('#file_list').append(  '<span>' + 'ファイル一覧ロード中' + '</span>'  );

    // 接続先のURL取得
    var base_dir = $('#base_dir')[0].innerHTML;
    var base_url = base_dir + 'index.php';

    var aj_url = base_url + '?module=User&action=FileListAjax&p=' + page + '&edtblg=' + $('#edtblg').val();

    $.ajax({
        url: aj_url,
        timeout: 30000 ,
        success: ok_filelist ,
        error  : ng_filelist
    });
};

// Ajax処理成功
function ok_filelist(data){
    $('#file_list').find("span:last").remove();
    $('#file_list').append( '<span>' + data + '</span>');
    // サイドメニューボタン設定
    setBtnHight("fileup_main", "fileup_btn");
};
// Ajax処理失敗
function ng_filelist( XMLHttpRequest, status, errorThrown ){
    // 通信エラーは何も表示しない
    // var disp_string = gf_getAjaxListErrorString( XMLHttpRequest, status);
    // $('#product_info').append( disp_string );
};

// ファイルの一覧からファイル情報埋め込み
function setFileEdit(btnobj,filename,blogid,fileid,position)
{
    // クリックされたボタンから親のTDを取得する。
    var elTable = $(btnobj).parents('table:first');

    // TD内からinputタグを取得
    var widthsize = elTable.find('input[name="filewidth"]').val();

    var img_flg    ="";
    var img_height ="";
    var img_width  ="";
    var text       ="";
    var imglink    ="";

    // inputタグが存在しない場合は画像でない。

    if (widthsize == null) {
        img_flg    = '&image=1';
    }
    else {

        // TD内からinputタグを取得
        var defimage_width = elTable.find('input[name="defimage_width"]').val();
        // TD内からinputタグを取得
        var defimage_height = elTable.find('input[name="defimage_height"]').val();

        // TD内からチェックボックスのチェックを取得
        imglink = elTable.find('input[name="imglink"]:checked').val();

        if (imglink == null) {
            imglink = "";
        }

        // INT変換
        widthsize       = Number(widthsize,10);
        defimage_width  = parseInt(defimage_width,10);
        defimage_height = parseInt(defimage_height,10);

        if (isNaN(widthsize) || widthsize <= 0) {
            alert("数字を入力してください。");
            return;
        }
        else {

            // 横のサイズから縦を計算
            var heightsize = defimage_height * widthsize / defimage_width;
            heightsize = parseInt(heightsize);
        }

        img_height = heightsize;
        img_width  = widthsize;
    }

    var img_src = 'index.php?module=Default&action=GetFile'+'&i_file_name='+encodeURIComponent(filename)+'&blog_sys_id='+blogid+img_flg+'&i_file_id='+fileid;

    img_src = tinymce.DOM.decode(img_src);

    var editor_tabs = $('#frm #entry_editor').tabs();
    var selected = editor_tabs.tabs('option', 'selected');

    var objEditor;
    if (selected == 0) {
        objEditor = $('#frm #entry_editor').find('#i_entry_text');
    }
    else {
        objEditor = $('#frm #entry_editor').find('#i_entry_text_more');
    }

    if (widthsize == null) {
        text = tinymce.DOM.createHTML('img', {
			src : img_src,
            align : position,
            alt : filename
		});
    }
    else {
        text = tinymce.DOM.createHTML('img', {
			src : img_src,
            align : position,
            width : img_width,
            height : img_height,
            alt : filename
		});
    }

    // 画像のリンクを追加する？
    if (imglink != "") {
        var text = '<a href="index.php?module=Default&action=GetFile&blog_sys_id=' + blogid + '&i_file_id=' + fileid + '" target="_blank">' + text + '</a>';
    }

    objEditor.tinymce().execCommand('mceInsertRawHTML', false, text);
};

// ファイルのpxをデフォルトに戻す
function clearFilePx(btnobj)
{
    // クリックされたボタンから親のTDを取得する。
    var elTd = $(btnobj).parents('td:first');
    // TD内からinputタグを取得
    var defimage_width = elTd.find('input[name="defimage_width"]').val();
    // TD内からinputタグを取得
    elTd.find('input[name="filewidth"]').val(defimage_width);
};

function filenextView(){
    // ファイル挿入画面のURL
    var fileurl = 'index.php?module=User&action=FileListSel&fr=1';
    // ファイル挿入画面表示
    window.open(encodeURI(fileurl), '_SelectFile'
           , 'width=470,height=500,scrollbars=yes,location=no,menubar=no,resizable=yes');
};
